=pod

Module O_A.pm

A component of the checker group of programs for monitoring applications, databases, networks, 
all types of servers, and more. By Nova Software, Inc. 

Copyright  by Nova Software, Inc. 2018  All rights reserved.  http://www.nova-sw.com

=cut 
  package O_A ; our $VERSION = 0.171125; use strict; use warnings; use sigtrap; use O_B 0.170611; use O_M 0.170611; use O_U 0.170611;
use O_L 0.170611; use IO::Socket;  use IO::Select; use Net::SMTP; use Authen::SASL 'Perl';  use MIME::Base64; BEGIN { use Exporter (); our @ISA = qw(Exporter); our @EXPORT = qw( i1A pzA siA wnA b2A rfA ); } sub i1A { wnA($_[0], $_[0], q1B) } sub siA {
my ($chA, $wwA) = @_; unless ($wwA and $chA) { urL(dyM(53, $wwA, $chA));   return; } shL($chA); my $stA = wnA($chA, $chA, $wwA); shL($stA) if $stA; } sub pzA { my ($chA, $wwA) = @_; my $tmp = seM.$chA; $chA .= "\n".wnA($tmp, $tmp, $wwA); mtL($chA); } sub wnA { my ($chA, $yiA, $wwA) = @_; return cwM(146) unless O_C::p1C(); return cwM(147) if ($wwA ne q1B and $wwA ne qjB and O_C::taC($wwA, 'criticality') eq (dxB)[0] );
$wwA ||= 'Unknown';   my $xvA = O_C::taC($wwA,'alertmethod'); $xvA ||= '';  my $stA = ''; $stA = jsA($chA) if $xvA =~/syslog/i; $stA .= fvA($chA, $yiA, $wwA) if $xvA =~/email/i ; return $stA; } sub fvA { my ($chA, $yiA, $wwA) = @_; $yiA ||= '';  $yiA =~s/\n/ /g; my $sjA = "By ".APP_N_HOST() ; $yiA = substr($yiA, 0, diB - 1)."... $sjA "; my $okA = scalar localtime(time()) ."\nO_C file: ".yfB(); my $bmA = $wwA eq q1B ? O_C::taC(q1B, 'adminmaillist') : mxA($wwA); $bmA ||= ''; my $stA = fiA($bmA, $yiA, $chA) if $bmA ; $stA ||='';
if ($wwA ne q1B and O_C::taC($wwA, 'criticality') eq (tuB)[0]) { my $mnA = mxA($wwA, 'text'); if ($mnA) { my $vrA = substr($yiA, 0, 155). '...'; my $tmp = fiA($mnA, '', $vrA); my $tmp2 = quotemeta $stA; $stA .= $tmp if ($tmp and $tmp !~/$tmp2/);  } } return $stA; } sub mxA { my ($wwA, $naA) = @_; my $msA = $naA ? 'text' : 'mail'; my $nkA = O_C::taC($wwA, $msA.'list'); $nkA ||= ''; if ( my @whA = split ',',O_C::taC($wwA, $msA.'listadd')) { foreach (@whA) { next unless $_; s/\s//g; 
$nkA .= ",$_"; } } if ( my @whA = split ',',O_C::taC($wwA, $msA.'listremove')) { foreach (@whA) { next unless $_; s/\s//g;  $_ = quotemeta($_); $nkA =~s/,{0,1}$_//g; } } shL(vbM.cwM(148, $wwA, $msA)) unless $nkA; return $nkA; } sub ekA { gxU($_[0]) } {  my $zmA = '';  my $hnA = 0;
my $csA = 0; sub fiA { my ($bmA, $yiA, $mkA) = @_; my $ncA = O_C::taC(q1B, 'mailserver'); return d1M.cwM(144, $ncA)  if $hnA >= 3 ; my $s2A = O_C::taC(q1B, 'mailfrom'); return d1M.cwM(145)  unless $s2A; my $sbA = O_C::taC(q1B, 'mxtimeout'); my $i4A = oeU(); my $hpA = "To: $bmA\nFrom: $s2A\nDate: $i4A\nSubject: $yiA\n\n"; my $stA = ''; my $wuA = ''; my $dkA = O_C::taC(q1B, 'mailserverports') ;  $zmA = '' unless $zmA =~/$dkA/;  my @luA = $zmA ? ($zmA) : split (',', $dkA ) ;  if ($ncA) { $s2A =~/@/;  foreach  (@luA) { $wuA = Net::SMTP->new($ncA, Port => $_, Timeout => $sbA, Debug => ffB, Hello=>$'); 
next unless $wuA; $zmA = $_;  last; } } else { return d1M.cwM(149); } unless ($wuA) {   $hnA++; return d1M.cwM(150, $ncA, @luA) ; } $hnA = 0; shL(cwM(151, $ncA, $zmA, $yiA)); my $crA = O_C::taC(q1B, 'mailfrompswd'); if ( $crA and not $csA) {  my $cgA = $crA; ($crA, my $vxA) = O_N::fgN($crA);   if ($vxA) { $stA = aqM.cwM(152, $vxA).cwM(155) ;
$csA = 1; } elsif ($crA eq $cgA ) { $stA .= cwM(153); } } else { $crA = '' }  if ($crA) {  my $yuA = 0;  my $bhA = 0; for $bhA ( (1,2) ) {  $yuA = $wuA->auth($s2A, $crA ); if ($yuA) { shL ( dyM( 70, $ncA,  $bhA ))  if $bhA > 1; last; }  } unless ($yuA) { $stA .= d1M.cwM(154, $ncA, $s2A).cwM(155) ; $csA = 1;
} } unless ($wuA->mail($s2A)) { $wuA->reset(); $wuA->quit(); undef $wuA; return $stA.aqM.cwM(156, $ncA, $s2A, d1M ); } my @bvA = split ',', $bmA; my @kcA = $wuA->to(@bvA, {SkipBad => 1 }); unless (@kcA) {  $wuA->reset(); $wuA->quit(); undef $wuA;  return $stA.aqM.cwM(157, $bmA, $ncA) ; } if ( @bvA > @kcA) { my @tmp = (); foreach my $gfA (@bvA) { my @tmp1 = grep ($_ eq $gfA, @kcA); 
push @tmp, $gfA if @tmp1 == 0; } $stA .= d1M.cwM(158, $ncA, @tmp)  if @tmp; } my $yuA = $wuA->data($hpA, $mkA); $stA .= aqM.cwM(159, $ncA, $hpA)  unless $yuA; $wuA->quit; undef $wuA;  return $stA; } sub rfA { $hnA = 0 } sub b2A { $csA = 0 } }  sub jsA { my ($chA) = @_;  my $awA = O_C::taC(q1B,'sysloghost'); return  igM.cwM(160)  unless $awA; my $qhA =  $chA =~/\*\*/ ? 3 : 5 ;  my $skA = ( ( O_C::taC(q1B, 'syslogfacility') << 3 ) | ($qhA) );  $chA = substr($chA,0,1024);
$chA =~s/\n/ /g; my $wiA = "<$skA>".phU().bhB().' '.riB()."\[$$\]: $chA"; my $voA = O_C::taC(q1B,'syslogport'); my $nsA = lc O_C::taC(q1B,'syslogmethod'); return (ecM.cwM(161, $nsA)) unless ($nsA eq 'udp' or $nsA eq 'tcp') ; my $jfA = IO::Socket::INET->new( PeerAddr    => $awA, PeerPort    => $voA, Proto       => $nsA, Type        => $nsA eq 'tcp' ? SOCK_STREAM : SOCK_DGRAM, Timeout     => 5, Blocking    => 1, ReuseAddr   => 1,  ); return aqM.cwM(162, $awA, $voA, $nsA, $!)  unless $jfA; print $jfA $wiA; undef $jfA;  return vbM.cwM(163, $awA, $voA, $nsA) ; }
sub END{} 1;
__DATA__
3j7l6XieCCcs5p1ucnlBmg

